---
title: MessageChannel
slug: Web/API/MessageChannel
tags:
  - API
  - Channel Messaging API
  - Interface
  - MessageChannel
  - Reference
  - web messaging
---
<p>{{APIRef("HTML DOM")}}</p>

<p>The <strong><code>MessageChannel</code></strong> interface of the <a href="/en-US/docs/Web/API/Channel_Messaging_API">Channel Messaging API</a> allows us to create a new message channel and send data through it via its two {{domxref("MessagePort")}} properties.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Properties">Properties</h2>

<dl>
	<dt>{{domxref("MessageChannel.port1")}} {{readonlyInline}}</dt>
	<dd>Returns port1 of the channel.</dd>
	<dt>{{domxref("MessageChannel.port2")}} {{readonlyInline}}</dt>
	<dd>Returns port2 of the channel.</dd>
</dl>

<h2 id="Constructor">Constructor</h2>

<dl>
	<dt>{{domxref("MessageChannel.MessageChannel", "MessageChannel()")}}</dt>
	<dd>
	<p>Returns a new <code>MessageChannel</code> object with two new {{domxref("MessagePort")}} objects.</p>
	</dd>
</dl>

<h2 id="Example">Example</h2>

<p>In the following example, you can see a new channel being created using the {{domxref("MessageChannel()", "MessageChannel.MessageChannel")}} constructor.</p>

<p>When the IFrame has loaded, we register an <code>onmessage</code> handler for  {{domxref("MessageChannel.port1")}} and transfer {{domxref("MessageChannel.port2")}} to the IFrame using the {{domxref("window.postMessage")}} method along with a message.</p>

<p>When a message is received back from the IFrame, the <code>onMessage</code> function outputs the message to a paragraph.</p>

<pre class="brush: js">var channel = new MessageChannel();
var output = document.querySelector('.output');
var iframe = document.querySelector('iframe');

// Wait for the iframe to load
iframe.addEventListener("load", onLoad);

function onLoad() {
  // Listen for messages on port1
  channel.port1.onmessage = onMessage;

  // Transfer port2 to the iframe
  iframe.contentWindow.postMessage('Hello from the main page!', '*', [channel.port2]);
}

// Handle messages received on port1
function onMessage(e) {
  output.innerHTML = e.data;
}
</pre>

<p>For a full working example, see our <a href="https://github.com/mdn/dom-examples/tree/master/channel-messaging-basic">channel messaging basic demo</a> on Github (<a href="https://mdn.github.io/dom-examples/channel-messaging-basic/">run it live too</a>).</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('HTML WHATWG', 'web-messaging.html#message-channels','Message channels')}}</td>
			<td>{{Spec2('HTML WHATWG')}}</td>
			<td> </td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MessageChannel")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/Channel_Messaging_API/Using_channel_messaging">Using channel messaging</a></li>
</ul>
